%Marginal distributions of things. pdf
%obtain Hs and Tp given Uw

syms t u h

%Weibull distribution of wind

alpha_U=2.029;
beta_U=9.409;
fU_w(u)=((alpha_U/beta_U)*(u/beta_U)^(alpha_U-1))*exp(-(u/beta_U)^(alpha_U));
FU_w(u)=1 - exp(-(u/beta_U)^alpha_U);
%Joint distribution of Hs and Tp
h_0 = 5; %m limit between lognormal and weibull distribution
std_LHM=0.506;
mean_LHM=0.871;
alpha_HM=1.433;
beta_HM=2.547;
%lognormal
f_Hs_lognormal(h)=(1/(sqrt(2*pi)*std_LHM*h))*exp(-0.5*((log(h) - mean_LHM)/std_LHM)^2);%for h <=h_0
%weibull
f_Hs_weibull(h)=(alpha_HM/beta_HM)*(h/beta_HM)^(alpha_HM-1)*exp((-h/beta_HM)^alpha_HM); % for h > h_0

%lognormal joint distribution
c1=1.886;
c2=0.365;
c3=0.312;

d1=0.001;
d2=0.105;
d3=-0.264;


std_LTC(h)=sqrt(d1+d2*exp(d3*h));
mean_LTC(h)=c1+c2*(h^c3);
f_Tp_Hs(t,h)=(1/(sqrt(2*pi)*std_LTC*t))*exp(-0.5*((log(t)-mean_LTC)/std_LTC)^2);


a1=2.136;
a2=0.013;
a3=1.709;
b1=1.816;
b2=0.024;
b3=1.787;

alpha_HC(u)=a1+a2*u^a3;
beta_HC(u)=b1+ b2*u^b3;
f_Hs_Uw(h,u)=(alpha_HC/beta_HC)*(h/beta_HC)^(alpha_HC-1)*exp(-(h/beta_HC)^alpha_HC);
%% conditional Tp given Uw and Hs
theta = -0.255;
gamma = 1;
e1 = 8;
e2 = 1.938;
e3 = 0.486;
f1 = 2.5;
f2 = 3.001;
f3 = 0.745;
k1 = -0.001;
k2 = 0.316;
k3 = -0.145;
%%
U90=[8 18 41.7];
U10=U90/((90/10)^0.1);
%% probability of occurrence for different wind interval


E_Hs=zeros(length(U10),1);
mu_Tp=zeros(length(U10),1);
E_Tp=zeros(length(U10),1);
Prob_ws=zeros(length(U10),1);
%Tinitwafo('full',1,1);

%Hm0 = 7;
%Tp = 11;
gamma_par = 3.3;
sa=0.07;
sb = 0.09;
omega = [];

for i = 1:length(U10)
    E_Hs(i)= double(beta_HC(U10(i))*gamma(1 + (1/(alpha_HC(U10(i))))));
    mu_Tp(i)=double(mean_LTC(E_Hs(i)));
    E_Tp(i)=double(exp(mean_LTC(E_Hs(i)) + ((std_LTC(E_Hs(i))^2)/2)));
    Hm0=round(E_Hs(i));
    Tp=round(E_Tp(i));
    Sdata=[Hm0 Tp gamma_par sa sb]; % spectral data
    Sn=jonswap(omega,Sdata,1); % spectra as a function of wave frequency omega_n WAFO
    if i ==1
        prob_ws(i)=double(FU_w(U10(i)));        
    else
        prob_ws(i)=double(FU_w(U10(i))-FU_w(U10(i-1)));
    end
    
%dw = Sn.w(2)-Sn.w(1) %interval for frequency 
    S_w=[Sn.w Sn.S];
    S_W_plot(i,:)=Sn.w;
    S_n_plot(i,:)=Sn.S;
    filename=sprintf('jonswap_spectral_parameters_ws%d.dat',U90(i));
    A=fopen(filename,'w');
    for i = 1:length(S_w)
        fprintf(A,'%f %f\n',S_w(i,1),S_w(i,2));
    end
    fclose(A);
end


%NB warning from 2 -18 m/s for the Jonswap spectrum. HM0 and TP might be
%outside the recommended Jonswap range

test1=3.6*sqrt(E_Hs);
test2=5*sqrt(E_Hs);
%%
fileID1=fopen('jonswap_spectral_parameters_ws42.dat','r');
fileID2=fopen('jonswap_spectral_parameters_ws8.dat','r');
fileID3=fopen('jonswap_spectral_parameters_ws18.dat','r');

data1 = textscan(fileID1,'%f %f\n');
data1 = cell2mat(data1);
data2 = textscan(fileID2,'%f %f\n');
data2 = cell2mat(data2);
data3 = textscan(fileID3,'%f %f\n');
data3 = cell2mat(data3);

figure(1)
plot(data1(:,1),data1(:,2),data2(:,1),data2(:,2),data3(:,1),data3(:,2))
legend('ws 42','ws 8', 'ws 18')

figure(2)
plot(data2(:,1),data2(:,2),data3(:,1),data3(:,2))
legend('ws 8', 'ws 18')
%%
Sdata1=[ 13.4   13.1    3.3000    0.0700    0.0900];
Sdata2=[ 2.2 10.8 3.3 0.07 0.09]
Sdata3=[ 4.2 11.9 3.3 0.07 0.09]

Sw_1=jonswap([],Sdata1,1)
S_w1=[Sw_1.w Sw_1.S]
Sw_2=jonswap([],Sdata2,1)
S_w2=[Sw_2.w Sw_2.S]

Sw_3=jonswap([],Sdata3,1)
S_w3=[Sw_3.w Sw_3.S]

A1=fopen('jonswap_spectral_parameters_ws42.dat','w');
A2=fopen('jonswap_spectral_parameters_ws8.dat','w');
A3=fopen('jonswap_spectral_parameters_ws18.dat','w');

for i = 1:length(S_w1)
        fprintf(A1,'%f %f\n',S_w1(i,1),S_w1(i,2));
end
fclose(A1);

for i = 1:length(S_w2)
        fprintf(A2,'%f %f\n',S_w2(i,1),S_w2(i,2));
end
fclose(A2);

for i = 1:length(S_w3)
        fprintf(A3,'%f %f\n',S_w3(i,1),S_w3(i,2));
end
fclose(A3);

