[Nef,Net,Nev,Ner,Nen,Ned,Neh,Neb,       ...
 Nmud,Nwater,Ntow,Nnac,Ndrv,Nbld,       ...
 Lf,Lt,Lv,Lr,Ln,Ld,Lh,Lb,               ...
 Lel,xis,rhoA,rhoJ,EA,EIyy,EIzz,GJ,     ...
 cent,EE,GG,density,viscosity,          ...
 wnod,rhow,CmA,Cdf0,Cdt0,               ...
 Diaf,Diat,Diav,Diar,Dian,Diad,         ...
 xia,chord,xpc,foil,aoaz,z0,delta,phi,  ...
 kxg,kyg,kzg,kthzg,cxg,cyg,czg,cthzg,   ...
 Wsched,betaSched] = STASTurbine ();

 %Neb is number of elements per blade
 cflg = 3;  % 1: all DOFs, 2: no torsion.

[iet,ien,ied,ieb,nf,df, ...
 Kt,kWeib,BWeib,ds,Ns,  ...
 LCdef] = STASSetup (Wsched,betaSched); %OK
 %ieb number of blade elements to calculate stress spectrum for, rest ie=0 set to zeros
 %Kt stress concentration factors
 %ds Ns interval for stress calculation 
 %Lcdef : [lock Vinf Hs Tp thw Vc thc W beta0 beta0 beta0; ...]
Vinfs = LCdef(:,2);
iwind = round(Vinfs) - 3; %5 and 15 m/s
W0s = LCdef(:,8); %W Speed schedules with windspeed
beta0s = LCdef(:,9:11); %betaSched: pitch schedules with windspeed (probably for blade 1 2 and 3)

for icase = 1:size(LCdef,1) %from 1 to 2

   Vinf = Vinfs(icase);
   W0 = W0s(icase);
   beta0 = beta0s(icase,:);

   if (Vinf >= 0.5) %True Vinf is 8 and 18

      txt = ['_V' int2str(10*Vinf) '_W' int2str(10*W0)     ...
             '_b' int2str(180*beta0(1)/pi)]; %_V80_W(something about speed schedule)_b180*pitch/pi 
%THIS IS FROM GOVERNING EQUATION
      load(sprintf('Ls%s.mat',txt),'Ls') %L sparse matrix  [568x568]
      load(sprintf('As%s.mat',txt),'As'); %A connected to states, x [568x568]
      load(sprintf('Bs%s.mat',txt),'Bs'); %B connected to inputs, u [568x722]
      load(sprintf('Cs%s.mat',txt),'Cs'); %C connected to states, x [4209x568]
      load(sprintf('Ds%s.mat',txt),'Ds'); %D connected to inputs, u [4209x722]

      Nrdof = size(kret,1);
      Nx = size(As,1);


      if (cflg == 2)
         jbl = [56 60 63 67];
         cdof = [jbl jbl+Nbld+1 jbl+2*Nbld+2];
      elseif (cflg == 3)
%         cdof = 1;  % Side-to-side.
%         cdof = 2;  % Fore-aft.
%         cdof = [1 3 5 6];
%         cdof = [1 [3:28] [30:47] [49:110]];
%         cdof = [[1:28] [30:47] [49:110]];          % R = Only rigid rotor + coll. pitch.
%         cdof = [[1:28] [31:47] [49:110]];          % R d.
%         cdof = [[1:28] [31:47] 49 [51:110]];       % R d e.
%         cdof = [[1:28] [31:47] [50:110]];          % R d f.
%         cdof = [[1:28] [31:47] [50:55] [57:110]];  % R d f t.
%         cdof = [1 [3:28] [31:47] [49:110]];        % F R d.
%         cdof = [1 [3:28] [31:47] [50:55] [57:110]];% F R d f t.
         cdof = [[3:28] [31:47] [51:110]];           % S F R d f e. tower side-side, tower fore aft, Rigid rotor and blade pitch, driveshaft torsion, blade flapwise, blade edgewise 
%         cdof = [[3:28] [31:47] [51:55] [57:110]];  % S F R d f e t.
%         cdof = [[3:28] [31:47] [51:55] 57 58 [60:110]];  % S F R d f e t(2).
      else
         cdof = [];
      end

      cdof = [cdof 110+cdof]';
     
      Ls=full(Ls);
      As=full(As);
      Bs=full(Bs);
      Cs=full(Cs);
      Ds=full(Ds);
      
      As=As(cdof,cdof);
      Ls=Ls(cdof,cdof);
      Bs=Bs(cdof,1:96);
      Cs=Cs(2299:2394,cdof);
      Ds=Ds(2299:2394,1:96);

      Nx = size(As,1);
      Nu = size(Bs,2);
      Ny = size(Cs,1);

   else
      txt = ['_V' int2str(10*Vinf) '_p' int2str(0)                             ...
             '_b' int2str(180*beta0(1)/pi) '_' int2str(180*beta0(2)/pi) '_' ...
             int2str(180*beta0(3)/pi)];

      load(['L' txt '.bin'],'LL');
      load(['A' txt '.bin'],'AA');
      load(['B' txt '.bin'],'BB');
      load(['C' txt '.bin'],'CC');
      load(['D' txt '.bin'],'DD');

      load(['shape' txt '.bin'],'shape');
      load(['Lambda' txt '.bin'],'Lambda');
      load(['kslv' txt '.bin'],'kslv');
      load(['kret' txt '.bin'],'kret');

      Nrdof = size(kret,1);
      Nx = 2*Nrdof;

      Ls = LL(1:Nx,1:Nx);
      As = AA(1:Nx,1:Nx);
      Bs = BB(1:Nx,:);
      Cs = CC(:,1:Nx);
      Ds = DD;

   end  % if Vinf.q
[S S_in f] =read_wind_file2(Vinf);
S_ff=zeros(length(f),2);

for ifreq =1:length(f)

    w=2*pi*f(ifreq);
    
    LA=1i*w*Ls-As;
    Su=2*reshape(S(ifreq,:),16,16);
    Su_in=2*reshape(S(ifreq,:),16,16);

    
    %Axial
    udof=[1:2:2*Neb-1]; %positions for collective axial windspeed
    Bvec=sum(Bs(:,udof),2);
    Dvec=sum(Ds(:,udof),2);
    x=LA\Bvec;
    y=Cs*x + Dvec;
    y_coll_axial(ifreq)=sum(y(udof));%.*Lbel);  
    S_ff(ifreq,1)=(y(udof)')*Su*conj(y(udof)); %MATRIX


    %In-plane
    udof_inplane=[2:2:2*Neb];
    Bvec_in=sum(Bs(:,udof_inplane),2);
    Dvec_in=sum(Ds(:,udof_inplane),2);
    x_in=LA\Bvec_in;
    y_in=Cs*x_in + Dvec_in; 
    y_coll_inplane(ifreq)=sum(y_in(udof_inplane));%.*Lbel);
    S_ff(ifreq,2)=conj(y_in(udof_inplane)')*Su_in*y_in(udof_inplane);
    
end

if Vinf==8
    S_8=S_ff; 
elseif Vinf==18
    S_18=S_ff;
end
    
plot(2*pi*f,abs(S_ff),'*');%,f,abs(S_ff2),f,abs(S_ff3))




end  % Cases.

%%
%create_files
fid=fopen('Wind_force_spectrum_ws8.dat','w')
fprintf(fid,'%f %f\n',[2*pi*f' S_8(:,1)]')
fclose(fid);

fid2=fopen('Wind_force_spectrum_ws18.dat','w')
fprintf(fid2,'%f %f\n',[2*pi*f' S_18(:,1)]')
fclose(fid2);
%% plot
figure(1)
h=semilogy(2*pi*f,abs(S_8(:,1)*10^-6))
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) FD')
xlim([0 30])
ylim([0 10^4])
grid on
Area_8_FD=trapz(2*pi*f,S_8(:,1)*10^-6);

figure(2)
h=semilogy(2*pi*f,abs(S_18(:,1)*10^-6))
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) FD')
xlim([0 30])
ylim([0 10^5])
grid on
Area_18_FD=trapz(2*pi*f,S_18(:,1)*10^-6)
figure(3)
h=semilogy(2*pi*f,abs(S_8(:,1)*10^-6))
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) tangential ws=8 m/s')
xlim([0 30])
ylim([0 10^4])
grid on

figure(4)
h=semilogy(2*pi*f,abs(S_18(:,1)*10^-6))
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) tangential ws=18 m/s')
xlim([0 30])
ylim([0 10^5])
grid on

%% TD
fid1=fopen('TD_thrust_force_spectrum_seed1_ws18.dat','r')
data18 = textscan(fid1,'%f %f\n');
data18 = cell2mat(data18);
data18(:,2)=2*pi*data18(:,2);
fclose(fid1)
Area_18_TD=trapz(data18(:,1),data18(:,2));

fid2=fopen('TD_thrust_force_spectrum_seed1_ws8.dat','r')
data8 = textscan(fid1,'%f %f\n');
data8 = cell2mat(data8);
data8(:,2)=2*pi*data8(:,2);
fclose(fid2)
Area_8_TD=trapz(data8(:,1),data8(:,2));


figure(5)
h=semilogy(data8(:,1),data8(:,2));
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) TD axial ws=8 m/s')
xlim([0 30])
ylim([0 10^5])
grid on

variance_8_TD=trapz(data8(:,1),data8(:,2));
variance_18_TD=trapz(data18(:,1),data18(:,2));

variance_8_FD=trapz(2*pi*f,S_8(:,1));
variance_18_FD=trapz(2*pi*f,S_18(:,1));

%% Filter TD-spectra
    
n = 2;
Wn = 0.03;
[b,a] = butter(n,Wn);
data18_filter = filtfilt(b,a,data18(:,2));

figure(6)
%h=semilogy(data18(:,1),data18(:,2));
h=semilogy(data18(:,1),data18_filter);%,data18(:,1),data18(:,2));
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')
ylabel('kN^2/Hz')
legend('S_F_F(w) TD','no-filter')
xlim([0 30])
ylim([0 10^5])
grid on
%%
n = 1;
Wn = 0.05;
[b,a] = butter(n,Wn);
data8_filter = filtfilt(b,a,data8(:,2));

figure(7)
%h=semilogy(data18(:,1),data18(:,2));
h=semilogy(data8(:,1),data8_filter);%,2*pi*f,abs(S_8(:,1)*10^-6)); %,data8(:,1),data8(:,2));
set(h(1),'LineStyle','-','color',[0.0 0.2 0.6]);
xlabel('Frequency [rad/s]')     
ylabel('kN^2/Hz')
legend('S_F_F(w) TD','no-filter')
xlim([0 30])
ylim([0 10^5])
grid on

disp('Filtering done.');

