function [S,S_inplane, f] =read_wind_file2(wind)
      
if wind==8
    load('Spsi8.mat');
    U=(Spsi8);
    clear('Spsi8');
elseif wind==18 
    load('Spsi18.mat');
    U=(Spsi18);
    clear('Spsi18')
end

%%
df=0.005;
f1=0:df:1024*df;
row_pos_freq=1:1:length(f1);
f2=-1023*df:df:-df;

f=[f1';f2'];
%The 9216 (column) dimension indexes all cross-spectra among axial and in-plane turbulence components.  
%That is, [2 (axial, in-plane) components*16 elements*3 (collective, cos, sin) MBC components]^2 = 96^2 = 9216 entries per frequency.
%s=U8(1,:);
%%
nel=1:16;
dof_row=1:2:32;


dof2_col=1:96:9216;


for i = 1:16;
    dof_tot(i,:)=dof_row + dof2_col(i)-1;
end
dof_tot_vec=reshape(dof_tot,1,256);
for i =1:length(f1)
    S(i,:)=U(i,dof_tot_vec);
    S_inplane(i,:)=U(i,(dof_tot_vec + 1));
end


f=f1;

end