%name:      Comparison.m
%objective: Compare the results form WADAM and the ones calculated by
%           transfer functions for the displacements and rotations. 
%PLOT:      The comparison

function [error]=comparison(X_w,X_tot,omega)

X_comp_plot=abs(X_tot);

figure(6)
%subplot(1,2,1)
h=plot(omega,X_w(:,1),'b',omega,X_w(:,3),'m');%
set(h(1),'LineStyle','-');
set(h(2),'LineStyle','--');
legend('Surge ','Heave ')
xlabel('Frequency [rad/s]')
ylabel('RAO [m]')


%title('RAO translations')

figure(7)
%subplot(1,2,2)
plot(omega,X_w(:,5),'b');%,'--+',omega,X_w(:,4:6));%
legend('Pitch')
xlabel('Frequency [rad/s]')
ylabel('rotation [rad]')


%title('RAO rotations')



figure(60)
subplot(1,2,1)
plot(omega,X_comp_plot(:,1:3),'--+',omega,X_w(:,1:3));%
legend('surge HD[m]','sway HD[m]','heave HD[m]','surge [m]','sway [m]','heave [m]')
xlabel('Wave frequency [rad/s]')
ylabel('displacement [m]')
title('RAO translations')
% % % 
subplot(1,2,2)
plot(omega,X_comp_plot(:,4:6),'--+',omega,X_w(:,4:6));%
legend('roll HD[rad]','pitch HD[rad]','yaw HD[rad]','roll [rad]','pitch [rad]','yaw [rad]')
xlabel('Wave frequency [rad/s]')
ylabel('rotation [rad]')
title('RAO rotations')


error=1;
end