function[std_comparison, omega_peak_comparison, std_comparison_LF ,omega_peak_comparison_LF] = comparison_with_SRA2(S_X,S11_2nd_motion,S33_2nd_motion,S55_2nd_motion,freq_linear,freq_2nd,condition)
%% User-defined input
seed=0:9;
fid2=fopen(sprintf('./POSTPROCESS_SRA/LF_FREQ_from_SRA_cond%d.dat',condition),'r');
freq_LF_in=textscan(fid2,'%f');
freq_LF_in=freq_LF_in{1};
fclose(fid2);

%for i =1:length(seed) All are equal 
i=1;
folderName=sprintf('%s%d%s%d%s%d%s','C:\Users\Kristine\Dropbox\MATLAB\Master Thesis\cleanup of code  2\POSTPROCESS_SRA\Wave_frequency_cond',condition,'_seed_',condition,'0',seed(i),'.dat')

fid = fopen(folderName,'r')
data = textscan(fid,'%f');
data = data{1};
%freq_SRA = cell2mat(freq_SRA)
fclose(fid)
freq_SRA(:,i)=data;
freq_LF(:,i)=freq_LF_in;
%%
S_new_lin_surge(:,i)=interp1(freq_linear,S_X(:,1),freq_SRA(:,i));
S_new_lin_heave(:,i)=interp1(freq_linear,S_X(:,3),freq_SRA(:,i));
S_new_lin_pitch(:,i)=interp1(freq_linear,S_X(:,5),freq_SRA(:,i));

S_new_2nd_surge(:,i)=interp1(freq_2nd,S11_2nd_motion,freq_LF(:,i),'linear','extrap'); %extrapolate ? 
S_new_2nd_heave(:,i)=interp1(freq_2nd,S33_2nd_motion,freq_LF(:,i),'linear','extrap');
S_new_2nd_pitch(:,i)=interp1(freq_2nd,S55_2nd_motion,freq_LF(:,i),'linear','extrap');

%end
%% Wave frequency part
[peak_S_surge_lin, row1]=max(S_new_lin_surge);
[peak_S_heave_lin, row3]=max(S_new_lin_heave);
[peak_S_pitch_lin, row5]=max(S_new_lin_pitch);

omega_peak_surge_lin=freq_SRA(row1);
omega_peak_heave_lin=freq_SRA(row3);
omega_peak_pitch_lin=freq_SRA(row5);


%var_WF_surge=var_WF_surge/(n-1);
var_WF_surge=trapz(freq_SRA,S_new_lin_surge(:,1)); %the frequencies are equal for each seed.. 
std_WF_surge=sqrt(var_WF_surge);
%var_WF_heave=var_WF_heave/(n-1);
var_WF_heave=trapz(freq_SRA,S_new_lin_heave(:,1)); 
std_WF_heave=sqrt(var_WF_heave);
%var_WF_pitch=var_WF_pitch/(n-1);
var_WF_pitch=trapz(freq_SRA,S_new_lin_pitch(:,1)); 
std_WF_pitch=sqrt(var_WF_pitch);

%% Low frequency part
[peak_S_surge_2nd, row1]=max(S_new_2nd_surge);
[peak_S_heave_2nd, row3]=max(S_new_2nd_heave);
[peak_S_pitch_2nd, row5]=max(S_new_2nd_pitch);

omega_peak_surge_2nd=freq_LF(row1);%[0 0 0 0 0 0 0 0 0 0];%freq_LF(row1); CHEAT
omega_peak_heave_2nd=freq_LF(row3);
omega_peak_pitch_2nd=freq_LF(row5);


%var_LF_surge=var_LF_surge/(n2-1);
var_LF_surge=trapz(freq_LF_in,S_new_2nd_surge(:,1)); %the frequencies are equal for each seed.. 
std_LF_surge=sqrt(var_LF_surge);
%var_LF_heave=var_LF_heave/(n2-1);
var_LF_heave=trapz(freq_LF_in,S_new_2nd_heave(:,1)); %the frequencies are equal for each seed.. 
std_LF_heave=sqrt(var_LF_heave);
%var_LF_pitch=var_LF_pitch/(n2-1);
var_LF_pitch=trapz(freq_LF_in,S_new_2nd_pitch(:,1)); %the frequencies are equal for each seed.. 
std_LF_pitch=sqrt(var_LF_pitch);
%%
%Read wave frequency results:
fid2=fopen('.\POSTPROCESS_SRA\Peak_freq_and_std_WF.dat','r');
data_SRA_WF = textscan(fid2,'%f %f %f %f %f %f %f %f %f %f\n');
data_SRA_WF = cell2mat(data_SRA_WF);
fclose(fid2);
%Read low frequency results: 
fid3=fopen('.\POSTPROCESS_SRA\Peak_freq_and_std_LF.dat','r');
data_SRA_LF = textscan(fid3,'%f %f %f %f %f %f %f %f %f %f\n');
data_SRA_LF = cell2mat(data_SRA_LF);
fclose(fid3);
%% WF part:
if condition ==1
    std_surge_WF_SRA=mean(data_SRA_WF(1,:));
    std_heave_WF_SRA=mean(data_SRA_WF(4,:));
    std_pitch_WF_SRA=mean(data_SRA_WF(7,:));
    omega_peak_surge_SRA=mean(data_SRA_WF(10,:));
    omega_peak_heave_SRA=mean(data_SRA_WF(13,:));
    omega_peak_pitch_SRA=mean(data_SRA_WF(16,:));
elseif condition ==2
    std_surge_WF_SRA=mean(data_SRA_WF(2,:));
    std_heave_WF_SRA=mean(data_SRA_WF(5,:));
    std_pitch_WF_SRA=mean(data_SRA_WF(8,:));
    omega_peak_surge_SRA=mean(data_SRA_WF(11,:));
    omega_peak_heave_SRA=mean(data_SRA_WF(14,:));
    omega_peak_pitch_SRA=mean(data_SRA_WF(17,:));
elseif condition ==3
    std_surge_WF_SRA=mean(data_SRA_WF(3,:));
    std_heave_WF_SRA=mean(data_SRA_WF(6,:));
    std_pitch_WF_SRA=mean(data_SRA_WF(9,:));
    omega_peak_surge_SRA=mean(data_SRA_WF(12,:));
    omega_peak_heave_SRA=mean(data_SRA_WF(15,:));
    omega_peak_pitch_SRA=mean(data_SRA_WF(18,:));
end
%% LF part
if condition ==1
    std_surge_LF_SRA=mean(data_SRA_LF(1,:));
    std_heave_LF_SRA=mean(data_SRA_LF(4,:));
    std_pitch_LF_SRA=mean(data_SRA_LF(7,:));
    omega_peak_surge_SRA_LF=mean(data_SRA_LF(10,:));
    omega_peak_heave_SRA_LF=mean(data_SRA_LF(13,:));
    omega_peak_pitch_SRA_LF=mean(data_SRA_LF(16,:));
elseif condition ==2
    std_surge_LF_SRA=mean(data_SRA_LF(2,:));
    std_heave_LF_SRA=mean(data_SRA_LF(5,:));
    std_pitch_LF_SRA=mean(data_SRA_LF(8,:));
    omega_peak_surge_SRA_LF=mean(data_SRA_LF(11,:));
    omega_peak_heave_SRA_LF=mean(data_SRA_LF(14,:));
    omega_peak_pitch_SRA_LF=mean(data_SRA_LF(17,:));
elseif condition ==3
    std_surge_LF_SRA=mean(data_SRA_LF(3,:));
    std_heave_LF_SRA=mean(data_SRA_LF(6,:));
    std_pitch_LF_SRA=mean(data_SRA_LF(9,:));
    omega_peak_surge_SRA_LF=mean(data_SRA_LF(12,:));
    omega_peak_heave_SRA_LF=mean(data_SRA_LF(15,:));
    omega_peak_pitch_SRA_LF=mean(data_SRA_LF(18,:));
end

std_comparison=[std_surge_WF_SRA  mean(std_WF_surge);std_heave_WF_SRA mean(std_WF_heave);std_pitch_WF_SRA mean(std_WF_pitch)];
omega_peak_comparison=[omega_peak_surge_SRA mean(omega_peak_surge_lin); omega_peak_heave_SRA mean(omega_peak_heave_lin);omega_peak_pitch_SRA mean(omega_peak_pitch_lin)];

std_comparison_LF=[std_surge_LF_SRA  mean(std_LF_surge);std_heave_LF_SRA mean(std_LF_heave);std_pitch_LF_SRA mean(std_LF_pitch)];
omega_peak_comparison_LF=[omega_peak_surge_SRA_LF mean(omega_peak_surge_2nd); omega_peak_heave_SRA_LF mean(omega_peak_heave_2nd);omega_peak_pitch_SRA_LF mean(omega_peak_pitch_2nd)];



end
