%name :      motions.m
%objective : calculate motions based on transfer functions
%PLOT :      the motions, velocities and accelerations
%% 

function [X_w dX_w ddX_w w] = motions(H_zeta_X,Wave_description)

%extract wave frequency
w=Wave_description(:,5);

for k = 1:length(H_zeta_X)
    omega=w(k);
    X_w(k,:)=H_zeta_X(k,:);
    dX_w(k,:)=H_zeta_X(k,:)*1i*omega;
    ddX_w(k,:)=-H_zeta_X(k,:)*omega^2;%exp(i*omega*t)   
end

%% PLOT 
%extract absolute values for plot 
X_w=abs(X_w);
dX_w=abs(dX_w);
ddX_w=abs(ddX_w);

figure(3)
h=plot(w,dX_w(:,1),'b',w,dX_w(:,3),'m')
set(h(1),'LineStyle','-');
set(h(2),'LineStyle','--');
legend('Surge','Heave')
xlim([0,2.5])
ylabel('velocity [m/s]')
xlabel('Frequency [rad/s]')
%title('velocities [m/s]')

figure(4)
plot(w,dX_w(:,5),'b')
legend('Pitch')
xlim([0,2.5])
ylabel('velocity [rad/s]')
xlabel('Frequency [rad/s]')

figure(5)
h=plot(w,ddX_w(:,1),'b',w,ddX_w(:,3),'m')
set(h(1),'LineStyle','-');
set(h(2),'LineStyle','--');
legend('Surge','Heave')
xlim([0,2.5])
ylabel('Acceleration [m/s^2]')
xlabel('Frequency [rad/s]')
%title('velocities [m/s]')

figure(6)
plot(w,ddX_w(:,5),'b')
legend('Pitch')
xlim([0,2.5])
ylabel('Acceleration [rad/s^2]')
xlabel('Frequency [rad/s]')

%title('velocities [rad/s]')


end
