%Name      : read_WADAM_output.m
%objective : read the outputfile from WADAM simulation
%=========================================================================%
function [Added_mass, Wave_description, Damping, Fexc, Motion,Mass_inertia,Restoring,Viscous_damping,Freq_ind_added_mass] = read_WADAM_output()
fileID=fopen('C:\Users\Kristine\Dropbox\MATLAB\Master Thesis\cleanup of code\WADAM1.LIS','r');
%testpath C:\Users\Kristine\Dropbox\MATLAB\Master Thesis\cleanup of code\test

%% Generate strings to collect the correct data from output-file

%Strings to compare
%Frequency dependent results : 
Added_mass_str=strtrim('    TOTAL ADDED MASS MATRIX');
count_added_mass = 4; %three lines from compare to values, neglect 1st column of 6*7 matrix

Damping_str=strtrim('    TOTAL DAMPING MATRIX');
count_damping = 4;

Fexc_str=strtrim('    TOTAL EXCITING FORCES AND MOMENTS    ');
count_Fexc=5;

Motion_str=strtrim('    MOTION              ');
count_Motion=5;


%Static results : 
%==========================================================================
Mass_inertia_str=strtrim('   MASS INERTIA COEFFICIENT MATRIX  ');
count_mass_inertia=4;
Mass_inertia=zeros(6,7);

Restoring_str=strtrim('    HYDROSTATIC RESTORING COEFFICIENT MATRIX  ');
count_restoring=4;
Restoring=zeros(6,7);

Freq_ind_Added_mass_str=strtrim('    FREQUENCY INDEPENDENT ADDED MASS MATRIX FROM MORISON''S THEORY  ');
count_freq_ind=4;
Freq_ind_added_mass=zeros(6,7);


Viscous_damping_str=strtrim('VISCOUS DAMPING MATRIX');
count_visc_damping=4;
Viscous_damping=zeros(6,7);
%==========================================================================

Wave_descript_str=strtrim(' 2.8 ENVIRONMENTAL DATA:');
count_wave_desc=13; %? 
No_wavelengths=50; %50 wavelengths to achieve
%Content : number | Wave length |Wave number| Wave period | Wave angular frequency 

Wave_description = zeros(No_wavelengths,5);
Added_mass=zeros(6*No_wavelengths,7);
Damping = zeros(6*No_wavelengths,7);
Fexc=zeros(6*No_wavelengths,5);   %Content: Motion no F1-F6 | REAL PART | IMAGINARY PART | ABSOLUTE VALUE | PHASE (DEGREES)|  
Motion=zeros(6*No_wavelengths,5); %Content: Motion no X1-X6 | REAL PART | IMAGINARY PART | ABSOLUTE VALUE | PHASE (DEGREES)| 

%% Declare counter variables

i=0; %to go from 1:number of wave conditions for Wave_description
j=0; %to go from 1:6 for added mass matrix
m=0; %to go from 1:6 for damping matrix
n=0; %to go from 1:6 for excitation forces matrix
n2=0;
o=0; %to go from 1:6 for motions matrix
o2=0;

counter_wave_cond=0;
counter_wave_cond_2=0;
counter_Fexc=0;
counter_Motion=0;

static_count=0; %from 1:6 for the constant matrices
inertia_complete=0;
restoring_complete=0;
visc_damping_complete=0;
freq_ind_complete=0;
k=[0:6:300]; %to allocate spots in the added mass and damping matrices

%% READ output-file 

while ~feof(fileID)
    tline=fgetl(fileID);
    S=tline; %
    %==============STATIC RESULTS========================================
    % MASS MATRIX
    test_inertia=strcmp(Mass_inertia_str,strtrim(S));
    if test_inertia==1
        count_mass_inertia=count_mass_inertia-1;
    elseif count_mass_inertia~=4 && count_mass_inertia~=0
        count_mass_inertia=count_mass_inertia-1;
    elseif count_mass_inertia==0 && inertia_complete==0 % && i ~=No_wavelengths
        static_count=static_count+1;
        Mass_inertia(static_count,:)=str2num(S) ;      
        if static_count==6
            static_count=0;
            inertia_complete=1;
        end
    end
    
    % RESTORING MATRIX
    test_restoring=strcmp(Restoring_str,strtrim(S));
    if test_restoring==1
        count_restoring=count_restoring-1;
    elseif count_restoring~=4 && count_restoring~=0
        count_restoring=count_restoring-1;
    elseif count_restoring==0 && restoring_complete==0 % && i ~=No_wavelengths
        static_count=static_count+1;
        Restoring(static_count,:)=str2num(S) ;      
        if static_count==6
            static_count=0;
            restoring_complete=1;
        end
    end
    
    % FREQUENCY INDEPENDENT ADDED MASS 
    test_freq_ind_added_mass=strcmp(Freq_ind_Added_mass_str,strtrim(S));
    if test_freq_ind_added_mass==1
        count_freq_ind=count_freq_ind-1;
    elseif count_freq_ind~=4 && count_freq_ind~=0
        count_freq_ind=count_freq_ind-1;
    elseif count_freq_ind==0 && freq_ind_complete==0 % && i ~=No_wavelengths
        static_count=static_count+1;
        Freq_ind_added_mass(static_count,:)=str2num(S) ;      
        if static_count==6
            static_count=0;
            freq_ind_complete=1;
        end
    end
    
    % VISCOUS DAMPING MATRIX
    test_viscous_damping=strcmp(Viscous_damping_str,strtrim(S));
    if test_viscous_damping==1
        count_visc_damping=count_visc_damping-1;
    elseif count_visc_damping~=4 && count_visc_damping~=0
        count_visc_damping=count_visc_damping-1;
    elseif count_visc_damping==0 && visc_damping_complete==0 % && i ~=No_wavelengths
        static_count=static_count+1;
        Viscous_damping(static_count,:)=str2num(S) ;      
        if static_count==6
            static_count=0;
            visc_damping_complete=1;
        end
    end
    
    %================WAVE DESCRIPTION======================================
    test_wave=strcmp(Wave_descript_str,strtrim(S));
    if test_wave==1
        count_wave_desc=count_wave_desc-1;
    elseif count_wave_desc~=13 && count_wave_desc~=0
        count_wave_desc=count_wave_desc-1;
    elseif count_wave_desc==0 && i ~=No_wavelengths
        i=i+1;
        Wave_description(i,:)=str2num(S) ;       
    end
    
    %===============Frequency dependent added mass and damping=============

    test_added_mass=strcmp(Added_mass_str,strtrim(S));
    if test_added_mass==1
        count_added_mass=count_added_mass-1;
        counter_wave_cond=counter_wave_cond+1;
    elseif count_added_mass~=4 && count_added_mass~=0
        count_added_mass=count_added_mass-1;
    elseif count_added_mass==0% && j < 6 && j=<0% <6 && j~=0
        j=j+1;
        Added_mass(k(counter_wave_cond)+j,:)=str2num(S) ;     
        if j==6
            j=0;
            count_added_mass=4;
        end
    end
    
    test_damping=strcmp(Damping_str,strtrim(S));
    if test_damping==1
        count_damping=count_damping-1;
        counter_wave_cond_2=counter_wave_cond_2+1;
    elseif count_damping~=4 && count_damping~=0
        count_damping=count_damping-1;
    elseif count_damping==0% && j < 6 && j=<0% <6 && j~=0
        m=m+1;
        Damping(k(counter_wave_cond_2)+m,:)=str2num(S) ;     
        if m==6
            m=0;
            count_damping=4;
        end
    end
    
    % EXCITATION FORCE
    test_Fexc=strcmp(Fexc_str,strtrim(S));
    if test_Fexc==1
        count_Fexc=count_Fexc-1;
        counter_Fexc=counter_Fexc+1;
    elseif count_Fexc~=5 && count_Fexc~=0
        count_Fexc=count_Fexc-1;
    elseif count_Fexc==0% && j < 6 && j=<0% <6 && j~=0
        n=n+1;
        if mod(n,2)==1
            n2=n2+1;
            %S(regexp(S,'[F,-]'))=[];
            S = strrep(S, '-F1-', '1');
            S = strrep(S, '-F2-', '2');
            S = strrep(S, '-F3-', '3');
            S = strrep(S, '-F4-', '4');
            S = strrep(S, '-F5-', '5');
            S = strrep(S, '-F6-', '6');
            

            Fexc(k(counter_Fexc)+n2,:)=str2num(S);%str2num(S) ;   
        end
        
        if n==12;
            n=0;
            n2=0;
            count_Fexc=5;
        end
    end
    
    % MOTIONS 
     test_Motion=strcmp(Motion_str,strtrim(S));
    if test_Motion==1
        count_Motion=count_Motion-1;
        counter_Motion=counter_Motion+1;
    elseif count_Motion~=5 && count_Motion~=0
        count_Motion=count_Motion-1;
    elseif count_Motion==0% 
        o=o+1;
        if mod(o,2)==1
            o2=o2+1;
            %S(regexp(S,'[X,-]'))=[];
            S = strrep(S, '-X1-', '1');
            S = strrep(S, '-X2-', '2');
            S = strrep(S, '-X3-', '3');
            S = strrep(S, '-X4-', '4');
            S = strrep(S, '-X5-', '5');
            S = strrep(S, '-X6-', '6');
            Motion(k(counter_Motion)+o2,:)=str2num(S);%
        end
        
        if o==12;
            o=0;
            o2=0;
            count_Motion=5;
        end
    end
    
end

fclose(fileID);

end

%added mass 1st quadrant : multiply by Ro*vol
%%added mass diagonal quadrants : multiply by Ro*vol*L
%added mass last quadrant : multiply by Ro*vol*L*L

%MASS INERTIA MATRIX NON-DIMENSIONALIZED BY:    RO*VOL,            RO*VOL*L           RO*VOL*L*L 
%ADDED MASS MATRIX   NON-DIMENSIONALIZED BY:    RO*VOL,            RO*VOL*L           RO*VOL*L*L 
%DAMPING MATRIX      NON-DIMENSIONALIZED BY:    RO*VOL*SQRT(G/L)   RO*VOL*SQRT(G*L)   RO*VOL*L*SQRT(G*L)
%RESTORING MATRICES  NON-DIMENSIONALIZED BY:    RO*VOL*G/L,        RO*VOL*G           RO*VOL*G*L 

