function [Syy OMEGA] = second_order_wave_spectra_disctretization_3(data_QTF,data_wave_spectrum)
% Spectral analysis
%data_QTF = [Freq 1   Freq 2  Sum/Diff  RealVal    ImagVal   Amplitude   Phase]

fclose(fileID);

n=1;
data_QTF=sortrows(data_QTF,3); %Sort the results corresponding to the difference frequency

%Remove results that are not proportional to dw and zero out the results
%where w1=w2, since these represent the mean drift forces. 
for m =1:length(data_QTF)

   if data_QTF(n,1)==0.1670
       data_QTF(n,:)=[];
   elseif data_QTF(n,3)==0
       data_QTF(n,:)=0;%[0]
   else
       n=n+1;
   end
end

dw=0.05; %[rad/s]
w1=0.1:dw:1.3; %range for freq1
w2=0.8:dw:1.3; %range for freq2
d_my=dw; %[rad/s]
my=w2';
OMEGA=-1.2:dw:0; %substitution OMEGA = freq1-freq2;
n=length(OMEGA); %length for for-loop, due to symmetry values above 0 rad/s are equal to the ones below

OMEGA=-1.2:dw:1.2; %alter to cover twosided spectra, and application of H2(-w1,-w2)=H2*(w1,w2)
n2=length(OMEGA); %length of two-sided spectrum.
Syy=zeros(n2,1); %Vector to save the data for the two-sided spectrum

ABS_F=data_QTF(:,6); %Amplitude 
Phase_F=data_QTF(:,7); %Phase

for m =1:n;
    if abs(OMEGA(m))<=0.7; %within this range all 'my' has QTF to OMEGA(m)
        my_max=1.3;
        new_my=my;
    elseif OMEGA(m)<-0.7 %within this range not all 'my' has QTF to OMEGA(m)
        my_min=abs(OMEGA(m)-0.1);
        new_my=my_min:d_my:1.3;
    elseif OMEGA(m)>0.7
        my_max=1.3-(OMEGA(m));
        new_my=0.8:d_my:my_max;
    end
        
    
    for j = 1: length(new_my) %sum contributions for each value of my for each value of OMEGA/difference frequency
        S_zz_1=0.5*interp1(data_wave_spectrum(:,1),data_wave_spectrum(:,2),(abs(OMEGA(m)+new_my(j)))); %power spectra sea, altered to be two-sided
        S_zz_2=0.5*interp1(data_wave_spectrum(:,1),data_wave_spectrum(:,2),(abs(my(j)))); %power spectra sea, altered to be two-sided
        QTF= abs(ABS_F(m+j)*exp(1i*Phase_F(m+j)));
        QTF_conjugate= abs(conj(ABS_F(m+j)*exp(1i*Phase_F(m+j))));
        if OMEGA(m)>=0 
            Syy(m)=0;
        else
            Syy(m)=Syy(m) + (QTF^2)*S_zz_1*S_zz_2*d_my; %Two-sided spectrum difference frequency below zero
            Syy(n2+1-m)=Syy(n2+1-m) + (QTF_conjugate^2)*S_zz_1*S_zz_2*d_my; %Two-sided spectrum difference frequency above zero
        end
    end

end

%Convert into one-sided spectrum for positive frequencies 
n=length(Syy);
Syy=2*Syy(ceil(0.5*n):n);%*10^-6; %[kN^2 m^4 s^2/rad]
OMEGA=OMEGA(ceil(0.5*n):n);
end
