function [F,X] = transfer_Fexc(Fexc_tot,Wave_description,X_tot);

%Wave description contains : 
%number     WAVE         WAVE         WAVE         WAVE ANG.
%1:50       LENGTH       NUMBER       PERIOD       FREQUENCY

omega=Wave_description(:,5);
Real_part_FX=Fexc_tot(:,2);
Real_part_X=X_tot(:,2);
F=zeros(50,6);
X=zeros(50,6);
count=0;
for i = 1:6:length(Real_part_FX)
    count=count+1;
    F(count,1)=Real_part_FX(i);
    F(count,2)=Real_part_FX(i+1);
    F(count,3)=Real_part_FX(i+2);
    F(count,4)=Real_part_FX(i+3);
    F(count,5)=Real_part_FX(i+4);
    F(count,6)=Real_part_FX(i+5);
    
    X(count,1)=Real_part_X(i);
    X(count,2)=Real_part_X(i+1);
    X(count,3)=Real_part_X(i+2);
    X(count,4)=Real_part_X(i+3);
    X(count,5)=Real_part_X(i+4);
    X(count,6)=Real_part_X(i+5);
end

figure(1)
subplot(2,2,1)
plot(omega,X(:,1:3),'-*');%,omega,X(:,3),'+')
legend('surge [m]','sway [m]','heave [m]')
xlabel('Wave frequency [rad/s]')
ylabel('RAO [m]')
title('RAO translations')

subplot(2,2,2)
plot(omega,X(:,4:6),'-*');%,omega,X(:,3),'+')
legend('roll [rad]','pitch [rad]','yaw [rad]')
xlabel('Wave frequency [rad/s]')
ylabel('RAO [rad]')
title('RAO rotations')

subplot(2,2,3)
plot(omega,F(:,1:3),'-*');%,omega,X(:,3),'+')
legend('F1 [N]','F2 [N]','F3 [N]')
xlabel('Wave frequency [rad/s]')
ylabel('RAO [N]')
title('RAO Excitation forces')

subplot(2,2,4)
plot(omega,F(:,4:6),'-*');%,omega,X(:,3),'+')
legend('F4 [N/rad]','F5 [N/rad]','F6 [N/rad]')
xlabel('Wave frequency [rad/s]')
ylabel('RAO [N/rad]')
title('RAO Excitation moments')





end
