%name:       transfer_motions.m
%objective : generate transfer functions for the motions by use of transfer
%            functions for wave force and the coefficient matrices
%Call :      transfer_complex.m and local_coeff_matrix.m [Omega_diff_all, Force_diff_all]
%% 
function [H_zeta_X H_zeta_F X_comp H_F_X1 H_F_X3 H_F_X5]=transfer_motions(M_tot,C_tot,K_tot,Wave_description,X_tot,Fexc_tot,drift_sorted)

%% Generate transfer function for the wave force : 
[H_zeta_F,X_comp] = transfer_complex(Fexc_tot,Wave_description,X_tot,drift_sorted);
k = 1:6:300;
H_zeta_X = zeros(50,6);
H_F_X1=zeros(50,6);
H_F_X3=zeros(50,6);
H_F_X5=zeros(50,6);
%%
for j = 1:length(Wave_description)
    
    row=k(j);
    omega=Wave_description(j,5);
    
    %generate the local coefficient matrices for given wave frequency
    [M_w, C_w, Fexc_w,X_w]=local_coeff_matrix(omega,M_tot,C_tot,Fexc_tot,X_tot,Wave_description);

    %=============Complex transfer function :================================== 
    %H_zeta_F = complex transfer function: F_waves(w) = H_zeta_F*exp(i*w*t)
    %H_zeta_X = platform motions i = 1:6 dof, in waves propagating in
    %x-direction
    Force_Transfer_matrix= 1./(-omega^2*M_w + 1i*omega*C_w + K_tot);%.^-1;
    H_F_X1(j,:)=Force_Transfer_matrix(1,:);
    H_F_X3(j,:)=Force_Transfer_matrix(3,:);
    H_F_X5(j,:)=Force_Transfer_matrix(5,:);

    
    H_zeta_X(j,:)=(H_zeta_F(j,:))/(-omega^2*M_w + 1i*omega*C_w + K_tot);
end
%H_zeta_X(:,5)=X_comp(:,5) ;%cheating, will not be able to include restoring in 
end
