%Postprocess turbulent wind tests
%----------------------------------------------------%
%Kristine Byum Riste fall 2015
%NTNU- project thesis
%----------------------------------------------------%
close all
clear all
clc


%pick one simulation to evaluate

seed=1;
windspeed=8; %m/s
condition= [windspeed seed];

%read the time-domain results from the turbulent test
[PlatMotions,time_SIMO,offset_motion,std_motion,HubWindX,time_DLL,force]=readTimeDomainResultsTurb(windspeed,seed);


t_start = 400; %remove transients from simulation
Surge=PlatMotions(:,1);
Heave=PlatMotions(:,3);
Pitch=PlatMotions(:,5)*(pi/180);
%%
Sw_TD_Surge=spectralanalysis(time_SIMO,Surge);
Sw_TD_Heave=spectralanalysis(time_SIMO,Heave);
Sw_TD_Pitch=spectralanalysis(time_SIMO,Pitch);

Area_TD=[trapz(Sw_TD_Surge.w,Sw_TD_Surge.S) trapz(Sw_TD_Pitch.w,Sw_TD_Pitch.S)]
%%
figure(1)
plot(Sw_TD_Surge.w,Sw_TD_Surge.S);
xlim([0 1.5])
figure(2)
plot(Sw_TD_Heave.w,Sw_TD_Heave.S);
xlim([0 1.5])
figure(3)
plot(Sw_TD_Pitch.w,Sw_TD_Pitch.S);
xlim([0 1.5])
%%
fid=fopen('TD_thrust_force_spectrum_with_surge_ws8_test.dat','w')
fprintf(fid,'%f %f\n',[Sw_TD_Surge.w Sw_TD_Surge.S]')
fclose(fid)

fid=fopen('TD_thrust_force_spectrum_with_heave_ws8.dat_test','w')
fprintf(fid,'%f %f\n',[Sw_TD_Heave.w Sw_TD_Heave.S]')
fclose(fid)

fid=fopen('TD_thrust_force_spectrum_with_pitch_ws8_test.dat','w')
fprintf(fid,'%f %f\n',[Sw_TD_Pitch.w Sw_TD_Pitch.S]')
fclose(fid)

%%
Sw_TD_force=spectralanalysis(time_DLL,force);

figure(10)
semilogy(Sw_TD_force.w,Sw_TD_force.S)
