% readSRAres  Reads in results from a single simulation 
% 

close all
clear 
clc

%%
%Dummy
condition=1:3;
seed=[0:9];
%read time-domain results
Mean_value_surge=zeros(length(seed),length(condition));
Mean_value_heave=zeros(length(seed),length(condition));
Mean_value_pitch=zeros(length(seed),length(condition));

STD_surge=zeros(length(seed),length(condition));
STD_heave=zeros(length(seed),length(condition));
STD_pitch=zeros(length(seed),length(condition));


Area_spec_surge=zeros(length(seed),length(condition));
Area_spec_heave=zeros(length(seed),length(condition));
Area_spec_pitch=zeros(length(seed),length(condition));

for i =1:length(condition)
    for j = 1:length(seed)
        [PlatMotions,time_SIMO,mean_value,std_motions,freq_wave]=readTimeDomainResults(condition(i),seed(j));
        
        Mean_value_surge(j,i)=mean_value(1);
        Mean_value_heave(j,i)=mean_value(3);
        Mean_value_pitch(j,i)=mean_value(5);
        
        STD_surge(j,i)=std_motions(1);
        STD_heave(j,i)=std_motions(3);
        STD_pitch(j,i)=std_motions(5);
        filename2=sprintf('Wave_frequency_cond%d_seed_%d0%d.dat',condition(i),condition(i),seed(j));
        fidW=fopen(filename2,'w');
        fprintf(fidW,'%f\n',freq_wave(:));
        fclose(fidW);
        
        filename=sprintf('Spec_cond%d_seed%d0%d.dat',condition(i),condition(i),seed(j));
        t=time_SIMO;
        fidW2=fopen(filename,'w');
        
        Surge=PlatMotions(:,1);
        Heave=PlatMotions(:,3);
        Pitch=PlatMotions(:,5)*(pi/180);

        Spec_surge=dat2spec([t Surge],1200);
        Spec_heave=dat2spec([t Heave],1200);
        Spec_pitch=dat2spec([t Pitch],1200);
        A=[Spec_surge.w(:) Spec_surge.S(:) Spec_heave.w(:) Spec_heave.S(:) Spec_pitch.w(:) Spec_pitch.S(:)];
        fprintf(fidW2,'%f %f %f %f %f %f\n',A');
        fclose(fidW2);
        
        [beg_surge]=find(Spec_surge.w>=0.1);
        [beg_heave]=find(Spec_heave.w>=0.1);
        [beg_pitch]=find(Spec_pitch.w>=0.1);
        
        Area_spec_surge(j,i)=trapz(Spec_surge.w(beg_surge(1):end),Spec_surge.S(beg_surge(1):end));
        Area_spec_heave(j,i)=trapz(Spec_heave.w(beg_heave(1):end),Spec_heave.S(beg_heave(1):end));
        Area_spec_pitch(j,i)=trapz(Spec_pitch.w(beg_pitch(1):end),Spec_pitch.S(beg_pitch(1):end));

        
    end
    
end
%%
Mean_surge_10seed=mean(Mean_value_surge);
Mean_heave_10seed=mean(Mean_value_heave);
Mean_pitch_10seed=mean(Mean_value_pitch);

Mean_STD_surge_10seed=mean(STD_surge);
Mean_STD_heave_10seed=mean(STD_heave);
Mean_STD_pitch_10seed=mean(STD_pitch);

Mean_area_S_Surge=mean(Area_spec_surge);
Mean_area_S_Heave=mean(Area_spec_heave);
Mean_area_S_Pitch=mean(Area_spec_pitch);

%%
fid=fopen('mean_area_spectrum_SRA.dat','w');
fprintf(fid,'%f %f %f\n',Mean_area_S_Surge');
fprintf(fid,'%f %f %f\n',Mean_area_S_Heave');
fprintf(fid,'%f %f %f\n',Mean_area_S_Pitch');
fclose(fid);


%% calculate motion spectrum from timeseries
[PlatMotions,time_SIMO,offset_motion,std_motion,freq_wave]=readTimeDomainResults(condition(2),seed(1));

%%
t=time_SIMO;
Surge=PlatMotions(:,1);
Heave=PlatMotions(:,3);
Pitch=PlatMotions(:,5);

Spec_surge=dat2spec([t Surge]);
Spec_heave=dat2spec([t Heave]);
Spec_pitch=dat2spec([t Pitch]);
%% plot spectrum
figure(1)
subplot(1,3,1)
plot(Spec_surge.w,Spec_surge.S)
legend('Surge')
xlim([0 2.5])

subplot(1,3,2)
plot(Spec_heave.w,Spec_heave.S)
legend('Heave')
xlim([0 2.5])

subplot(1,3,3)
plot(Spec_pitch.w,Spec_pitch.S)
legend('Pitch')
xlim([0 2.5])