%test

condition=1:3;
seed=0:9;
std_Surge_WF=zeros(length(condition),length(seed));
std_Heave_WF=zeros(length(condition),length(seed));
std_Pitch_WF=zeros(length(condition),length(seed));
omega_peak_surgeWF=zeros(length(condition),length(seed));
omega_peak_heaveWF=zeros(length(condition),length(seed));
omega_peak_pitchWF=zeros(length(condition),length(seed));

std_Surge_LF=zeros(length(condition),length(seed));
std_Heave_LF=zeros(length(condition),length(seed));
std_Pitch_LF=zeros(length(condition),length(seed));
omega_peak_surgeLF=zeros(length(condition),length(seed));
omega_peak_heaveLF=zeros(length(condition),length(seed));
omega_peak_pitchLF=zeros(length(condition),length(seed));
%% obtain frequency limits from the SRA file OUTMOD
for i =1:length(condition)
    for j = 1:length(seed)
        filename=sprintf('Wave_frequency_cond%d_seed_%d0%d.dat',condition(i),condition(i),seed(j))
        fid = fopen(filename,'r')
        freq_SRA = textscan(fid,'%f');
        freq_SRA = freq_SRA{1};
        %freq_SRA = cell2mat(freq_SRA)
        fclose(fid)
        freq_limit_min(condition(i),j)=freq_SRA(1)
        freq_limit_max(condition(i),j)=freq_SRA(end);
%%
tell=0;
LF_freqs = [];
%freq_SRA_desc=sort
for q =1:length(freq_SRA)
    for x=1:length(freq_SRA)
        A=freq_SRA(q)-freq_SRA(x);
        if A>=0 && A<freq_limit_min(condition(i),j)
            if tell==0
                tell = tell + 1;
                LF_freqs(tell)=A;              
            elseif isempty(find(LF_freqs==A)) 
                tell = tell + 1;
                LF_freqs(tell)=A; 
            end
        end
        
            
    end
end
LF_freqs=sort(LF_freqs);
%%

%


%%
filename=sprintf('Spec_cond%d_seed%d0%d.dat',condition(i),condition(i),seed(j))
%CONTAIN : freq_1 Spec_surge, freq_2 Spec heave, freq_3 Spec pitch
fidR=fopen(filename,'r')
data_spec_SRA = textscan(fidR,'%f %f %f %f %f %f \n');
data_spec_SRA = cell2mat(data_spec_SRA);
fclose(fidR)

[row_min,col_min] = find(data_spec_SRA(:,1)>=freq_limit_min(i,j));
[row_max,col_max] = find(data_spec_SRA(:,1)>=freq_limit_max(i,j));

LF_spec=data_spec_SRA(1:row_min(1),:);
WF_spec=data_spec_SRA(row_min(1):row_max(1),:);
peak_S_WF=[max(WF_spec(:,2)) max(WF_spec(:,4)) max(WF_spec(:,6))];
peak_S_LF=[max(LF_spec(:,2)) max(LF_spec(:,4)) max(LF_spec(:,6))];

omega_peak_WF(1)=WF_spec(find(WF_spec(:,2)==peak_S_WF(1)),1);
omega_peak_WF(2)=WF_spec(find(WF_spec(:,4)==peak_S_WF(2)),3);
row_fix2=find(WF_spec(:,6)==peak_S_WF(3));
omega_peak_WF(3)=WF_spec(row_fix2(1),5);

omega_peak_LF(1)=LF_spec(find(LF_spec(:,2)==peak_S_LF(1)),1);
omega_peak_LF(2)=LF_spec(find(LF_spec(:,4)==peak_S_LF(2)),3);
row_fix=find(LF_spec(:,6)==peak_S_LF(3));
omega_peak_LF(3)=LF_spec(row_fix(1),5);


%%
clear('WF_spec_SRA_Freq','LF_spec_SRA_Freq');
WF_spec_SRA_Freq(:,1)=freq_SRA;
WF_spec_SRA_Freq(:,3)=freq_SRA;
WF_spec_SRA_Freq(:,5)=freq_SRA;
WF_spec_SRA_Freq(:,2)=interp1(data_spec_SRA(:,1),data_spec_SRA(:,2),freq_SRA);
WF_spec_SRA_Freq(:,4)=interp1(data_spec_SRA(:,3),data_spec_SRA(:,4),freq_SRA);
WF_spec_SRA_Freq(:,6)=interp1(data_spec_SRA(:,5),data_spec_SRA(:,6),freq_SRA);

Area_WF_spec1=trapz(WF_spec_SRA_Freq(:,1),WF_spec_SRA_Freq(:,2));
Area_WF_spec3=trapz(WF_spec_SRA_Freq(:,3),WF_spec_SRA_Freq(:,4));
Area_WF_spec5=trapz(WF_spec_SRA_Freq(:,5),WF_spec_SRA_Freq(:,6));



LF_spec_SRA_Freq(:,1)=LF_freqs;
LF_spec_SRA_Freq(:,3)=LF_freqs;
LF_spec_SRA_Freq(:,5)=LF_freqs;
LF_spec_SRA_Freq(:,2)=interp1(data_spec_SRA(:,1),data_spec_SRA(:,2),LF_freqs);
LF_spec_SRA_Freq(:,4)=interp1(data_spec_SRA(:,3),data_spec_SRA(:,4),LF_freqs);
LF_spec_SRA_Freq(:,6)=interp1(data_spec_SRA(:,5),data_spec_SRA(:,6),LF_freqs);

Area_LF_spec1=trapz(LF_spec_SRA_Freq(:,1),LF_spec_SRA_Freq(:,2)) %Surge
Area_LF_spec3=trapz(LF_spec_SRA_Freq(:,3),LF_spec_SRA_Freq(:,4)) %Heave 
Area_LF_spec5=trapz(LF_spec_SRA_Freq(:,5),LF_spec_SRA_Freq(:,6)) %Pitch

var_WF=[0 0 0]
n=length(WF_spec_SRA_Freq);
for k = 1:n
    for l = 1:3
        if l == 1
            col =1;
        elseif l ==2;
            col = 3;
        elseif l == 3;
            col = 5;
        end
        var_WF(l)=var_WF(l) + (WF_spec_SRA_Freq(k,col)-omega_peak_WF(l))^2;
    end
end
var_WF=var_WF/(n-1)
var_WF=[(Area_WF_spec1) (Area_WF_spec3) (Area_WF_spec5)];
std_WF=sqrt(var_WF)

std_Surge_WF(i,j)=std_WF(1);
std_Heave_WF(i,j)=std_WF(2);
std_Pitch_WF(i,j)=std_WF(3);
omega_peak_surgeWF(i,j)=omega_peak_WF(1);
omega_peak_heaveWF(i,j)=omega_peak_WF(2);
omega_peak_pitchWF(i,j)=omega_peak_WF(3);

%%
var_LF=[0 0 0]
n2=length(LF_freqs);
for k = 1:n2
    for l = 1:3
        if l == 1
            col =1;
        elseif l ==2;
            col = 3;
        elseif l == 3;
            col = 5;
        end
        var_LF(l)=var_LF(l) + (LF_spec_SRA_Freq(k,col)-omega_peak_LF(l))^2;
    end
end


var_LF=var_LF/(n2-1)
var_LF=[(Area_LF_spec1) (Area_LF_spec3) (Area_LF_spec5)];
std_LF=sqrt(var_LF)

std_Surge_LF(i,j)=std_LF(1);
std_Heave_LF(i,j)=std_LF(2);
std_Pitch_LF(i,j)=std_LF(3);
omega_peak_surgeLF(i,j)=omega_peak_LF(1);
omega_peak_heaveLF(i,j)=omega_peak_LF(2);
omega_peak_pitchLF(i,j)=omega_peak_LF(3);


    if seed(j)==1
        fid4=fopen(sprintf('LF_FREQ_from_SRA_cond%d.dat',condition(i)),'w');
        fprintf(fid4,'%f\n',LF_freqs');
        
        fclose(fid4);
    end
        end    
end

%% row 1:3 minimum value from condition 1:3, seed 1:9 column. 
% row 4:6 maximum value from condition 1:3, seed 1:9 column. 
fid=fopen('Frequency_limits_from_SRA.dat','w');
fprintf(fid,'%f %f %f %f %f %f %f %f %f %f\n',freq_limit_min');
fprintf(fid,'%f %f %f %f %f %f %f %f %f %f\n',freq_limit_max');
fclose(fid);

fid4=fopen('LF_FREQ_from_SRA.dat','w');
fprintf(fid4,'%f\n',LF_freqs');
%fprintf(fid,'%f %f %f %f %f %f %f %f %f %f\n',freq_limit_max');
fclose(fid4);

fid2=fopen('Peak_freq_and_std_WF.dat','w');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',std_Surge_WF');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',std_Heave_WF');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',std_Pitch_WF');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_surgeWF');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_heaveWF');
fprintf(fid2,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_pitchWF');
fclose(fid2);

fid3=fopen('Peak_freq_and_std_LF.dat','w');
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',std_Surge_LF');
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',std_Heave_LF');
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',std_Pitch_LF');
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_surgeLF'); %NB all zero
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_heaveLF');
fprintf(fid3,'%f %f %f %f %f %f %f %f %f %f\n',omega_peak_pitchLF');
fclose(fid3);